﻿import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class Saavn(AlbumArtDownloader.Scripts.IScript, ICategorised):
	Name as string:
		get: return "Saavn"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "Alex Vallat"
	Category as string:
		get: return "Indian"

	def Search(artist as string, album as string, results as IScriptResults):
		artist = StripCharacters("&.'\";:?!", artist)
		album = StripCharacters("&.'\";:?!", album)
		
		resultsPage = GetPage(GetStreamWithUserAgent("http://www.saavn.com/search/album/" + System.Web.HttpUtility.UrlPathEncode("\"" + artist + "\" \"" + album + "\"")))
		
		resultsRegex = Regex("<div class=\"art album-art\">\\s*<a href=\"(?<url>[^\"]+)\"[^>]+>\\s*<img src=\"(?<image>[^\"]+?)150x150\\.jpg\" alt=\"(?<title>[^\"]+?) songs,", RegexOptions.Singleline | RegexOptions.IgnoreCase)
		resultsMatches = resultsRegex.Matches(resultsPage)
	
		results.EstimatedCount = resultsMatches.Count;
		
		for resultsMatch as Match in resultsMatches:
  			imageRoot = resultsMatch.Groups["image"].Value;
  			url = resultsMatch.Groups["url"].Value;
  			title = resultsMatch.Groups["title"].Value;
  			results.Add(imageRoot + "150x150.jpg", title, url, 500, 500, imageRoot + "500x500.jpg", CoverType.Front);

	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter

	static def GetStreamWithUserAgent(url as string):
		request = System.Net.HttpWebRequest.Create(url) as System.Net.HttpWebRequest
		request.UserAgent = "Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:49.0) Gecko/20100101 Firefox/49.0"
		response = request.GetResponse()
		return response.GetResponseStream()